#+title: XKB Mode
#+PROPERTY: header-args :tangle xkb-mode.el :mkdirp yes :comments link
#+PROPERTY: header-args:wisent-grammar :tangle grammar.wy
#+auto_tangle: t

* LICENSE

This document is released under the [[https://www.gnu.org/licenses/fdl-1.3.html][GNU Free Documentation License]], Version 1.3.

#+begin_quote
Copyright (C) 2023 Martin Baulig

Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.3
or any later version published by the Free Software Foundation;
with no Invariant Sections, no Front-Cover Texts, and no Back-Cover Texts.
A copy of the license is included in the section entitled "GNU
Free Documentation License".
#+end_quote

All code sections and code samples in this document - as well as the tangled
Emacs Lisp code files =xkb-mode.el= and =xkb-ast.el= - are released under the
[[https://www.gnu.org/licenses/gpl-3.0.html][GNU General Public License]], Version 3.

#+begin_quote
Copyright (C) 2023 Martin Baulig

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
#+end_quote

* File Header

File header for =xkb-mode.el=.

#+html: <details><summary>File Header</summary>
#+begin_src emacs-lisp :shebang ";;; xkb-mode.el --- Description -*- lexical-binding: t; -*-"
;; Copyright (C) 2023 Martin Baulig

;; Author: Martin Baulig <martin@baulig.is>
;; Maintainer: Martin Baulig <martin@baulig.is>
;; Created: April 10, 2023
;; Modified: April 21, 2023
;; Version: 0.0.1
;; Homepage: https://gitlab.com/martin-baulig/config-and-setup/xkb-mode
;; Package-Requires: ((emacs "26.1"))

;; This file is not part of GNU Emacs.

;; This program is free software; you can redistribute it and/or
;; modify it under the terms of the GNU General Public License as
;; published by the Free Software Foundation, either version 3 of
;; the License, or (at your option) any later version.

;; This software is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <https://www.gnu.org/licenses/>.

;;; Commentary:
;;
;; PLEASE DO NOT MANUALLY EDIT THIS FILE!  It is automatically
;; generated from README.ORG.

;;; Code:
#+end_src
#+html: </details>

#+html: <details><summary>File Header</summary>
#+begin_src emacs-lisp
(require 'semantic/wisent)
(require 'semantic/debug)
(require 'semantic/format)
(require 'semantic/decorate/mode)
(require 'semantic/ctxt)

(require 'evil-core)
(require 'compile)
(require 'flycheck)

(require 'highlight-numbers)

(require 'wisent-xkb-wy (expand-file-name "./wisent-xkb-wy.el"))
#+end_src
#+html: </details>

File header for =xkb-ast.el=.

#+html: <details><summary>xkb-ast.el</summary>
#+begin_src emacs-lisp :tangle xkb-ast.el :shebang ";;; xkb-ast.el --- Description -*- lexical-binding: t; -*-"
;; Copyright (C) 2023 Martin Baulig

;; Author: Martin Baulig <martin@baulig.is>
;; Maintainer: Martin Baulig <martin@baulig.is>
;; Created: April 13, 2023
;; Modified: April 21, 2023
;; Version: 0.0.1
;; Homepage: https://gitlab.com/martin-baulig/config-and-setup/xkb-mode
;; Package-Requires: ((emacs "26.1"))

;; This file is not part of GNU Emacs.

;; This program is free software; you can redistribute it and/or
;; modify it under the terms of the GNU General Public License as
;; published by the Free Software Foundation, either version 3 of
;; the License, or (at your option) any later version.

;; This software is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <https://www.gnu.org/licenses/>.

;;; Commentary:
;;
;; PLEASE DO NOT MANUALLY EDIT THIS FILE!  It is automatically
;; generated from README.ORG.

;;; Code:
#+end_src
#+html: </details>

#+html: <details><summary>xkb-ast.el</summary>
#+begin_src emacs-lisp :tangle xkb-ast.el
(require 'semantic/wisent)
(require 'semantic/wisent/grammar)
(require 'semantic/grammar)

(require 'compat-29)
#+end_src
#+html: </details>

* Introduction

** About

This is mostly a research project that goes alongside my *Moonlander Configuration* project.  It is a custom Wisent Grammar for the XKB files that are used by X11 to define keyboard layouts.

Writing this has not only been a refresher of my existing knowledge of Bison-style context-free grammars, but also helped me tremendously to get myself more familiar with Lisp and Emacs Lisp.

The entirety of this project has been done in Doom Emacs using my new Moonlander keyboard with my own custom-made layout.

** Grammar Style and Use of Wisent

When I first started to write this, I used Bison style because that's what I was familiar with.  Then, I started to play around with Iterative Style, and quickly started to like it's flexibility and better error handling capabilities.  I got to the point where it could parse the entire file in three iterations with great error recovery and a much simplified grammar.

While this worked great for syntax highlighting - even with somewhat badly malformed input - the way how Semantic turns everything into a list of tags turned out to be a bit problematic and properly expanding these tags recursively without duplicates quickly became a big mess.

In addition to syntax highlighting, I would also like to do full-buffer code reformatting - and for that, having an actual, type-safe AST is essential.

Therefore, I decided to move away from Semantic and use the Wisent parser directly, making it return AST Nodes instead of Tags. Since Iterative Style had already worked so well before, I have now incorporated it into the new parser.

We are still using three iterations - but instead of expanding Semantic Tags from inside grammar macros, we now create AST Nodes, which are instances of EIEIO Classes.  Each parser iteration returns a fully type-safe AST - possibly containing abstract blocks  that still need to be expanded in a further iteration.  We will do so during an AST Traversal outside of the actual parser.

This means that the grammar itself - and all of it's macros, etc. - is now free of the iteration / re-parsing logic - which makes in much cleaner and easier to understand.

Using Wisent directly also allows us to use it's more flexible token format - which allows for an arbitrary Emacs Lisp type in the ~VALUE~ field.  This is quite useful to construct some of the AST Nodes directly in the Lexer, where they have full access to the regular expression and it's match groups.

** Current Status

The proof-of-concept part of this is now about complete.

Lexing and Parsing the =xkb_keycodes= section - the only of the three sections that is currently implemented in the grammar - has already been stable for a couple of days.

Syntax highlighting works great with the new AST Visit based decorations.

And I just added a prototype version of a code formatter that uses the fully-parsed AST to output the entire document in a nicely formatted way.  Using Wisent-style tokens with a fully constructed AST Node has been working great for this.  Adding the different comment statement types should be pretty-much straightforward.

It should approximately take me about another week or so to finish this, and then maybe another week to add some finishing polishes.  But overall, I am feeling very good about this.

Investing that entire week to get the foundations right, to switch from using Semantic Tags to a fully type-safe AST based on EIEIO Classes, that has definitely been the right thing to do.

I'm about to head out to enjoy a long weekend with friends, and this is really the perfect point to take a break.

* AST Context

** Generic AST Context

#+begin_src emacs-lisp :tangle xkb-ast.el
(defclass xkb-ast-context ()
  ((indent :initform 0 :type integer))
  :documentation "Abstract AST Context."
  :abstract t)

(cl-defgeneric xkb-ast-context-error (this msg-or-fmt &rest args)
  "Report error in AST Context THIS.

If the optional ARGS argument is present, then MSG-OR-FMT will
be interpreted as a `format' specifier.

Otherwise, it is the string to be printed.")

(cl-defgeneric xkb-ast-context-debug (this msg-or-fmt &rest args)
  "Debug-Print MSG-OR-FMT with ARGS in AST Context THIS.")
#+end_src

*** Utility Functions

Formatting helper.

#+begin_src emacs-lisp :tangle xkb-ast.el
(defsubst xkb-ast--format-maybe-args (maybe-context message-or-format &rest maybe-args)
  "Safely `format' MESSAGE-OR-FORMAT with MAYBE-ARGS.

If the optional `xkb-ast-context' MAYBE-CONTEXT has been provided,
then its' current indentation level will be applied."
  (condition-case error-message
      (let ((indent (if maybe-context
                        (make-string (* 4 (oref maybe-context indent)) ?\s)
                      ""))
            (formatted (if (null maybe-args)
                           ;; MESSAGE-OR-FORMAT is a simple message, but we must still guard
                           ;; against potential formatting characters inside it (which may
                           ;; for instance happen inside an error handler).
                           (format "%s" message-or-format)
                         ;; We got a format string and list of arguments.
                         (apply #'format message-or-format maybe-args))))
        (concat indent formatted))
    (error (format "ERROR: `xkb-ast--format-maybe-args' called with malformed arguments:
ERROR: %S
FORMAT: >>>|%S|<<<
ARGS (%s): >>>|%S|<<<"
                   error-message message-or-format (length maybe-args) maybe-args))))
#+end_src

Error helper.

#+begin_src emacs-lisp :tangle xkb-ast.el
(cl-defmacro xkb-ast-with-error-handler (context body &key error-handler)
  "Execute BODY with error handling.

On error, `xkb-ast-context-error' is invoked with CONTEXT and the
error message. If provided, the optional ERROR-HANDLER is invoked
with the error message as well."
  `(condition-case error-message ,body
     ((debug error)
      (xkb-ast-context-error ,context error-message)
      (when ,error-handler
        (funcall ,error-handler error-message)))))
#+end_src

Increase indentation level.

#+begin_src emacs-lisp :tangle xkb-ast.el
(defmacro xkb-ast--context-with-indent (context body)
  "Eval BODY with increased indentation level in CONTEXT."
  `(with-slots (indent) context
     (cl-incf indent)
     ,body
     (cl-decf indent)))
#+end_src

*** List Types

Check whether something is a list of something else.

#+begin_src emacs-lisp :tangle xkb-ast.el
(cl-deftype xkb-ast-list-type (type)
  `(satisfies (lambda (obj)
               (cond ((null obj) t)
                     ((consp obj)
                      (-all-p (lambda (item) (cl-typep item ,type)) obj))
                     (t nil)))))
#+end_src

*** Default Implementation

#+begin_src emacs-lisp :tangle xkb-ast.el
(cl-defmethod xkb-ast-context-print ((this xkb-ast-context) msg-or-fmt &rest args)
  "Pretty-Print MSG-OR-FMT with ARGS in abstract context THIS."
  (let ((text (apply #'xkb-ast--format-maybe-args this msg-or-fmt args)))
    (xkb-ast-context-debug this "%s" text)
    (message "%s" text)))

(cl-defmethod xkb-ast-context-debug ((_ xkb-ast-context) _ &rest _)
  "Default implementation; does nothing.")

(cl-defmethod xkb-ast-context-error ((_ xkb-ast-context) msg-or-fmt &rest args)
  "Default implementation; just display the error message.

If the optional ARGS argument is present, then MSG-OR-FMT will
be interpreted as a `format' specifier.

Otherwise, it is the string to be printed."
  (message "XKB AST ERROR: %s"
           (apply #'xkb-ast--format-maybe-args nil msg-or-fmt args)))
#+end_src

** Debugging Context

#+begin_src emacs-lisp :tangle xkb-ast.el
(defclass xkb-ast-debug-context (xkb-ast-context) ()
  "Debugging context.")

(cl-defmethod xkb-ast-context-debug ((this xkb-ast-debug-context) msg-or-fmt &rest args)
  "Debug-Print MSG-OR-FMT with ARGS and indentation from THIS."
  (message "%s" (apply #'xkb-ast--format-maybe-args this msg-or-fmt args)))
#+end_src

** Interactive Context

#+begin_src emacs-lisp :tangle xkb-ast.el
(defclass xkb-ast-interactive-context (xkb-ast-debug-context)
  ((separator :allocation :class :initform (make-string 45 ?=) :read-only t))
  "Interactive Context.")

(cl-defmethod xkb-ast-context-print
  :after ((this xkb-ast-interactive-context) msg-or-fmt &rest args)
  "Pretty-Print MSG-OR-FMT with ARGS in `xkb-ast-interactive-context' THIS."
  (let ((formatted (apply #'xkb-ast--format-maybe-args this msg-or-fmt args)))
    (princ formatted)
    (terpri)))

(cl-defmethod xkb-ast-context-error
  :after ((this xkb-ast-interactive-context) msg-or-fmt &rest args)
  "Print ERROR-MESSAGE in `xkb-ast-interactive-context' THIS."
  (xkb-ast-context-print this "XKB AST ERROR: %s"
                         (apply #'xkb-ast--format-maybe-args this msg-or-fmt args)))
#+end_src

** Region

Type-safe representation of the region between two points.  We provide a special overloaded constructor here to allow both the regular =(xkb-ast-region :start 1 :end 9)= as well as using a ~cons~ cell =(xkb-ast-region '(1 . 9))=.

#+begin_src emacs-lisp :tangle xkb-ast.el
(defclass xkb-ast-region ()
  ((start :type integer :initarg :start :initform (point-min))
   (end :type integer :initarg :end :initform (point-max)))
  "Region between START and END.")

(cl-defmethod shared-initialize ((this xkb-ast-region) &rest slots)
  "Constructor override for `xkb-ast-region' THIS.

In addition to the usual key-value pairs, we allow SLOTS to
be a single (START . END) pair for convenience."
  (if (and (consp (car-safe (car-safe slots)))
           (eq 1 (length slots))
           (eq 1 (length (car-safe slots)))
           (integerp (car-safe (car-safe (car-safe slots))))
           (integerp (cdr-safe (car-safe (car-safe slots)))))
      (let ((region (car (car slots))))
        (oset this start (car region))
        (oset this end (cdr region)))
    (cl-call-next-method)))

(cl-defmethod cl-print-object ((this xkb-ast-region) stream)
  "Pretty print `xkb-ast-region' THIS onto STREAM."
  (with-slots (start end) this
    (princ (format "(%s,%s)" start end) stream)))
#+end_src

Misc helpers.

#+begin_src emacs-lisp :tangle xkb-ast.el
(defsubst xkb-ast-region-to-cons (region)
  "Turn `xkb-ast-region' REGION into (START . END) pair."
  (with-slots (start end) region (cons start end)))

(defsubst xkb-ast-region-to-list (region)
  "Turn `xkb-ast-region' REGION into (START END) list."
  (with-slots (start end) region (list start end)))

(cl-defmacro xkb-ast-with-region (region &rest body)
  "Execute BODY with the region narrowed to REGION."
  `(save-mark-and-excursion
     (save-restriction
       (with-slots (start end) (cl-the xkb-ast-region ,region)
         (narrow-to-region start end)
         (goto-char start))
       ,@body)))
#+end_src

** AST Node

This is the abstract base class for all of our AST Nodes.

#+begin_src emacs-lisp :tangle xkb-ast.el
(defclass xkb-ast-node ()
  ((region :initarg :region :type xkb-ast-region))
  "Abstract AST Base Node."
  :abstract t)
#+end_src

We provide a default pretty-print function that will print the class name and the region.

#+begin_src emacs-lisp :tangle xkb-ast.el
(cl-defmethod cl-print-object ((this xkb-ast-node) stream)
  "Pretty print `xkb-ast-node' THIS onto STREAM."
  (let ((pretty-region (cl-prin1-to-string (oref this region))))
    (princ (format "[%s %s]" (type-of this) pretty-region) stream)))
#+end_src

* AST Traversal

We provide an abstract =xkb-ast-visitor= base class here with two operations:

- =xkb-ast-visit= is a read-only operation that will traverse the entire tree, visiting each node once.

- =xkb-ast-traverse= is intended to modify and / or rewrite the tree structure.

Note that both here as well as in the Lexer and Parser code above, these methods take both a =context= as well as a =visitor= argument.  This is to allow specializations based on the AST Context.

  #+begin_src emacs-lisp :tangle xkb-ast.el
(defclass xkb-ast-visitor () ()
  "Abstract AST Visitor base class.")


(cl-defmethod xkb-ast-visit ((context xkb-ast-context) (visitor xkb-ast-visitor) node)
  "AST Visiting, default implementation.

This default implementation does nothing.

CONTEXT is the `xkb-ast-context' to use for diagnostics and output.
VISITOR is the current visitor, a subclass of `xkb-ast-visitor'.
NODE is the current Node, an instance of `xkb-ast-node'.")


(cl-defgeneric xkb-ast-traverse (context visitor node)
  "AST Traversal, default implementation.

This default implementation simply returns the current NODE.

CONTEXT is the `xkb-ast-context' to use for diagnostics and output.
VISITOR is the current visitor, a subclass of `xkb-ast-visitor'.
NODE is the current Node, an instance of `xkb-ast-node'.")
  #+end_src

In =xkb-ast-debug-context=, we print all the nodes.

#+begin_src emacs-lisp
(cl-defmethod xkb-ast-visit :around ((context xkb-ast-debug-context) _ node)
  "Print current NODE prior to visiting it in `xkb-ast-debug-context' CONTEXT."
  (xkb-ast-context-print context "VISIT: %s" (cl-prin1-to-string node))
  (cl-call-next-method)
  (xkb-ast-context-print context "VISIT DONE: %s" (cl-prin1-to-string node)))


(cl-defmethod xkb-ast-traverse :around ((context xkb-ast-debug-context) _ node)
  "Debug-wrap traversing NODE in `xkb-ast-debug-context' CONTEXT."
  (xkb-ast-context-print context "TRAVERSE: %s" (cl-prin1-to-string node))
  (let ((result (cl-call-next-method)))
    (xkb-ast-context-print context "TRAVERSE DONE: %s - %s"
                           (cl-prin1-to-string node)
                           (cl-prin1-to-string result))
    result))
#+end_src

** Decoration

Decorations (syntax highlighting) will be added by means of an AST Visit pass with =xkb-ast-decoration-visitor=.

#+begin_src emacs-lisp :tangle xkb-ast.el
(defclass xkb-ast-decoration ()
  ((region :initarg :region :type xkb-ast-region)
   (face :initarg :face :type face)))
#+end_src

#+begin_src emacs-lisp :tangle xkb-ast.el
(cl-defmethod cl-print-object ((this xkb-ast-decoration) stream)
  "Pretty print `xkb-ast-decoration' THIS onto STREAM."
  (let ((pretty-region (cl-prin1-to-string (oref this region)))
        (face (oref this face)))
    (princ (format "{%s: %s}" pretty-region face) stream)))
#+end_src

#+begin_src emacs-lisp :tangle xkb-ast.el
(defclass xkb-ast-decoration-visitor (xkb-ast-visitor)
  ((decorations :type (xkb-ast-list-type xkb-ast-decoration) :initform nil)))
#+end_src

* Grammar Header and Declarations

** Header

#+begin_src wisent-grammar
%package wisent-xkb-wy
%languagemode xkb-mode
%start first-iteration-start

%% Iterative re-entry
%start block
%start keycodes-block-statement
#+end_src

We need this later in the macros section.

#+begin_src wisent-grammar
%{
(require 'semantic/wisent/grammar)
(require 'xkb-ast (expand-file-name "./xkb-ast"))
%}
#+end_src

** Macros

#+begin_src wisent-grammar
%use-macros xkb-ast
{
        EXPAND-REGION, FULL-REGION, EXPAND-SUBCLASS,

        BLOCK, STATEMENT, SYNTAX-ERROR, BLANK-LINE,

        BUILTIN, KEYWORD,

        FIRST-ITERATION-ROOT, RAW-KEYCODES-BLOCK,

        KEYCODE-VALUE,
        KEYCODE-MINIMUM, KEYCODE-MAXIMUM, KEYCODE-ASSIGN
}
#+end_src

** Keywords

#+begin_src wisent-grammar
%keyword KEY "key"
%keyword XKB-KEYCODES "xkb_keycodes"
%keyword MINIMUM "minimum"
%keyword MAXIMUM "maximum"
#+end_src

** Tokens

#+begin_src wisent-grammar
%token <identifier> IDENTIFIER
%token <section-name> SECTION-NAME

%token <brace-block> BRACE-BLOCK

%token <statement> STATEMENT

%token <blank-line> BLANK-LINE
%token <full-line-comment> FULL-LINE-COMMENT
%token <code-comment> CODE-COMMENT
%token <babel-start-comment> BABEL-START-COMMENT
%token <babel-end-comment> BABEL-END-COMMENT

%token <open-paren> LBRACE "{"
%token <close-paren> RBRACE "}"

%token <operator> EQUALS "="
%token <operator> SEMICOLON ";"

%token <keycode> KEYCODE
%token <digit> DIGIT
#+end_src

That is the end of the header and we can move on to the main grammar.
#+begin_src wisent-grammar
%%
#+end_src

** Grammar Macros

In this section, we define some EIEIO Classes to provide a type-safe and robust AST.  The corresponding Instances should only be constructed using their respective macros.

*** AST Node Macro

The ~EXPAND-REGION~ macro can be used in the grammar file with a =$I= region placeholder, like for instance =(EXPAND-REGION $5)=.  It can either be used in a Node constructor's =:region= keywords - or as one of it's arguments, for instance to record some sub-rule's region without constructing an actual Node for it.

#+begin_src emacs-lisp :tangle xkb-ast.el
(defun xkb-ast-EXPAND-REGION (symbol)
  "Grammar macro to construct the `xkb-ast-region'.

SYMBOL is a $I placeholder symbol that gives the bounds of the area."
  (let ((region (or (wisent-grammar-region-placeholder symbol)
                    (error "Invalid region symbol: '%s'" symbol))))
    `(xkb-ast-region ,region)))
#+end_src

The ~FULL-REGION~ macro is what is used by default when a Node is constructed without an explicit =:region= keyword.

#+begin_src emacs-lisp :tangle xkb-ast.el
(defun xkb-ast-full-region ()
  "Grammar macro to construct the `xkb-ast-region'.

Constructs the region from the current rule's full
input data."
  (if (or $region
          (setq $region (nthcdr 2 wisent-input)))
     (xkb-ast-region $region)
    (xkb-ast-region :start (point-max) :end (point-max))))

(defun xkb-ast-FULL-REGION ()
  "Grammar macro to construct the `xkb-ast-region'.

Constructs the region from the current rule's full
input data."
  `(xkb-ast-full-region))
#+end_src

Sub-classing a Node that has been constructed by the lexer.

#+begin_src emacs-lisp :tangle xkb-ast.el
(defun xkb-ast-EXPAND-SUBCLASS (class parent &optional inherit &rest extra-args)
  "Construct AST sub-class Node.

PARENT is an AST Node that has been constructed by the Lexer; so it is a
subclass of `xkb-ast-lexer-node'.

We want to specialize that and create an instance of CLASS (short form),
which is a sub-class of PARENT's class - and use the PARENT instance to
fill in all the inherited slots.

EXTRA-ARGS are additional keyword arguments to be passed to our constructor."
  (cl-flet* ((make-key (name) (intern (concat ":" (symbol-name name))))
             (key-and-value (name) `(,(make-key name) ,name)))
    (let* ((class-name (intern (concat "xkb-ast-" (symbol-name class))))
           (all-slots `(token region full-region ,@inherit))
           (all-args (mapcan #'key-and-value all-slots)))
      `(with-slots (,@all-slots) ,parent
         (,class-name ,@all-args)))))
#+end_src

* Defining AST Nodes

The ~xkb-ast-define-node~ macro takes care of constructing both the AST Classes as well as the corresponding grammar macros to construct Nodes.

Unfortunately, this macro has grown to a point where it's quite complex and complicated.  It should probably be split into smaller pieces at some point.

It automatically creates appropriate specializations for =cl-print-object=, a standard  =xkb-ast-visit= that will enter all of the class slots, as well as a customized one via =xkb-ast-decoration-visitor=.

#+begin_src emacs-lisp :tangle xkb-ast.el
(cl-defmacro xkb-ast-define-ast-node
    (type &key base-class abstract doc-string slots
          no-grammar-macro decorate extra-decorations)
  "Define new AST Node.

TYPE is the node's class name, for instance 'keyword'.

DECORATE specifies the decoration to be used for this Node.
It can either by a symbol to specify an existing face or a
face specification.

EXTRA-DECORATIONS is a list of (SLOT . FACE) pairs.

SLOTS is a list of Slot Specifiers.

Each Slot Specifier is either a symbol or a list of the
slot name followed by key-value pairs.  For instance:

    (name :type int)

Currently, the following keywords are supported:

  - :type           - Specifies the slot's type.
  - :class          - Shortcut for `xkb-ast-<VALUE>`.
  - :list-class     - Like :class, but it's a list.
  - :maybe-class    - Like :class, but it's optional.

  - :indent         - Boolean, increase indentation level.

The optional DOC-STRING is used as documentation for that
structure type.

The optional BASE-CLASS can be used to specify a custom base
class instead of the default `xkb-ast-node'.

If ABSTRACT is non-nil, then this class will be declared abstract.

Unless NO-GRAMMAR-MACRO is non-nil, we define a `xkb-ast-KEYWORD'
function to create such a node, which can then be used in the
grammar as \"(KEYWORD :region $1)\".

This grammar macro takes an optional `:region' keyword
argument.  When provided, it specifies a $I region placeholder
to provide the region."
  (cl-flet*
      ((car-or-self (item) (if (consp item) (car item) item))
       (make-key (item) (intern (concat ":" (symbol-name (car-or-self item)))))
       (map-key-and-name (item) (let ((name (car-or-self item))) `(,(make-key name) ,name)))
       (map-plist (func plist) (while plist
                                 (funcall func (car plist) (cadr plist))
                                 (setq plist (cddr plist))))
       (check-slot-spec (item)
                        (cond ((symbolp item)
                               (cons item nil))
                              ((and (consp item) (symbolp (car item)) (plistp (cdr item)))
                               (let ((has-type nil))
                                 (map-plist (lambda (key value)
                                              (let ((plist (cdr item)))
                                                (cond ((eq :type key)
                                                       (cl-check-type value symbol)
                                                       (and has-type (signal 'invalid-slot-spec `(,key . "duplicate type spec")))
                                                       (setq has-type t))
                                                      ((eq :class key)
                                                       (cl-check-type value symbol)
                                                       (and has-type (signal 'invalid-slot-spec `(,key . "duplicate type spec")))
                                                       (setq has-type t))
                                                      ((eq :maybe-class key)
                                                       (cl-check-type value symbol)
                                                       (and has-type (signal 'invalid-slot-spec `(,key . "duplicate type spec")))
                                                       (setq has-type t))
                                                      ((eq :list-class key)
                                                       (cl-check-type value symbol)
                                                       (and has-type (signal 'invalid-slot-spec `(,key . "duplicate type spec")))
                                                       (setq has-type t))
                                                      ((eq :indent key)
                                                       (cl-check-type value boolean))
                                                      ((eq :print key)
                                                       (cl-check-type value boolean))
                                                      ((eq :visit key)
                                                       (cl-check-type value (member normal list maybe)))
                                                      (t (signal 'invalid-slot-spec `(,key . "invalid key"))))))
                                            (cdr item)))
                               item)
                              (t (signal 'invalid-slot-spec item))))
       (map-type (type) (intern (concat "xkb-ast-" (symbol-name type))))
       (slot-decl (desc) (let* ((name (car desc))
                                (type nil)
                                (args `(:initarg ,(make-key name))))
                           (map-plist (lambda (key value)
                                        (cond ((eq :type key)
                                               (setq type value)
                                               (plist-put args :type value))
                                              ((eq :class key)
                                               (plist-put args :type (map-type value)))
                                              ((eq :list-class key)
                                               (plist-put args :type `(xkb-ast-list-type ,(map-type value))))
                                              ((eq :maybe-class key)
                                               (plist-put args :type `(or null ,(map-type value))))))
                                      (cdr desc))
                           `(,name ,@args)))
       (visitor-call (desc) (let* ((name (car desc))
                                   (plist (cdr desc))
                                   (indent (plist-get plist :indent))
                                   (call (cond ((plist-member plist :class)
                                                `(xkb-ast-visit context visitor (oref node ,name)))
                                               ((plist-member plist :list-class)
                                                `(mapc (apply-partially #'xkb-ast-visit context visitor)
                                                  (oref node ,name)))
                                               ((plist-member plist :maybe-class)
                                                `(let ((value nil))
                                                   (when (and (slot-boundp node ,(make-key name))
                                                              (not (null (setq value (oref node ,name)))))
                                                     (xkb-ast-visit context visitor value)))))))
                              (if (and indent call)
                                  `(xkb-ast--context-with-indent context ,call)
                                call)))
       (print-slot (desc) (let* ((name (car desc))
                                 (key (symbol-name (make-key name))))
                            (when (plist-get (cdr desc) :print)
                              `(lambda () (when (and (slot-boundp this ',name) (oref this ,name))
                                            (list ,(format "%s" key) (cl-prin1-to-string (oref this ,name))))))))
       (extra-decoration (decl)
                         (or (consp decl) (signal 'invalid-extra-decorations decl))
                         `(xkb-ast-decoration :region (oref node ,(car decl)) :face ,(cdr decl)))
       (make-extra-decorations ()
                               (cond ((null extra-decorations) nil)
                                     ((listp extra-decorations)
                                      (mapcar #'extra-decoration extra-decorations))
                                     (t (signal 'invalid-extra-decorations (type-of extra-decorations)))))
       (slot-optional-p (desc) (plist-get (cdr-safe desc) :maybe-class))
       (slot-printed-p (desc) (plist-get (cdr-safe desc) :print))
       (slot-required-p (desc) (not (slot-optional-p desc))))
    (let* ((name (symbol-name (cl-the symbol type)))
           (class-type (intern (concat "xkb-ast-" name)))
           (macro-func (intern (concat "xkb-ast-" (upcase name))))
           (macro-comment (concat "Create a new `" name "' class."))
           (checked-slots (mapcar #'check-slot-spec slots))
           (optional-slot-names (mapcar #'car-or-self (seq-filter #'slot-optional-p checked-slots)))
           (required-slots (seq-filter #'slot-required-p checked-slots))
           (slot-names (mapcar #'car-or-self required-slots))
           (slot-decls (mapcar #'slot-decl checked-slots))
           (ctor-slots (mapcan #'map-key-and-name checked-slots))
           (print-slots (mapcar #'print-slot (seq-filter #'slot-printed-p checked-slots)))
           (visitor-calls (seq-filter #'consp (mapcar #'visitor-call checked-slots)))
           (effective-base-classes (cond ((null base-class)
                                          (list xkb-ast-node))
                                         ((symbolp base-class)
                                          (list (map-type base-class)))
                                         ((listp base-class)
                                          (mapcar #'map-type base-class))))
           (extra-options (when abstract '(:abstract t)))
           (face-decl (when decorate
                        (let ((face-name class-type)
                              (face-spec (cond ((symbolp decorate)
                                                `'((t :inherit ,decorate)))
                                               ((consp decorate)
                                                decorate)
                                               (t (signal 'invalid-decoration '(name . decorate))))))
                          `(defface ,face-name ,face-spec
                             ,(concat "Face associated with `xkb-ast-" name "' AST Node.")
                             :group 'xkb))))
           (all-decorations (append (when decorate
                                      (list `(xkb-ast-decoration :region (oref node region) :face ,class-type)))
                                    (make-extra-decorations)))
           (has-decorations (not (null all-decorations))))
      `(progn
         (defclass ,class-type (,@effective-base-classes)
           ,slot-decls
           ,@extra-options
           :documentation ,doc-string)
         (unless ,no-grammar-macro
           (cl-defun ,macro-func (,@slot-names &key region ,@optional-slot-names) ,macro-comment
                     (let ((expand-region (if region (xkb-ast-EXPAND-REGION region)
                                            (xkb-ast-FULL-REGION))))
                       `(,,class-type :region ,expand-region ,@(list ,@ctor-slots)))))
         (cl-defmethod xkb-ast-visit ((context xkb-ast-context) (visitor xkb-ast-visitor) (node ,class-type))
           ;; (xkb-ast-context-print context "AUTOMATIC VISIT: %s" (cl-prin1-to-string node))
           ,@visitor-calls
           ;; (xkb-ast-context-print context "AUTOMATIC VISIT DONE: %s" (cl-prin1-to-string node))
           )
         (cl-defmethod cl-print-object ((this ,class-type) stream)
           ,(concat "Pretty print `xkb-ast-" name "' THIS onto STREAM.")
           (let* ((pretty-region (cl-prin1-to-string (oref this region)))
                  (items (mapcan #'funcall (list ,@print-slots)))
                  (joined (mapconcat #'identity items " "))
                  (sep (if (> (length joined) 0) " " "")))
             (princ (format "[%s %s%s%s]" (type-of this) pretty-region sep joined) stream)))
         (when ,face-decl ,face-decl)
         (when ,has-decorations
           (cl-defmethod xkb-ast-visit :after
             ((context xkb-ast-context) (visitor xkb-ast-decoration-visitor) (node ,class-type))
             (xkb-ast-context-print context "DECORATE NODE: %s" (cl-prin1-to-string node))
             (with-slots (decorations) visitor
               (setq decorations (append decorations (list ,@all-decorations))))))))))
#+end_src

* Main Grammar

** Generic Parser

Generally speaking, a "parser specification" consists of two element: which Lexical Analyzer to use and where to start.  We reflect this in the abstract =xkb-ast-parser-spec= base class.

#+begin_src emacs-lisp :tangle xkb-ast.el
(defclass xkb-ast-parser-spec ()
  ((analyzer :type symbol :allocation :class)
   (start :type symbol :allocation :class))
  "Abstract AST Parser Specification."
  :abstract t)
#+end_src

For each Iteration, we define a singleton derived class.

#+begin_src emacs-lisp :tangle xkb-ast.el
(defclass xkb-ast-first-iteration-parser (xkb-ast-parser-spec eieio-singleton) ()
  "First Iteration Parser."
  :singleton t)

(cl-defmethod shared-initialize :after ((class xkb-ast-first-iteration-parser) &rest _)
  "Static Constructor for `xkb-ast-first-iteration-parser' CLASS."
  (oset class analyzer 'xkb-lex)
  (oset class start 'first-iteration-start))
#+end_src

#+begin_src emacs-lisp :tangle xkb-ast.el
(defclass xkb-ast-statement-parser (xkb-ast-parser-spec eieio-singleton) ()
  "Second Iteration Parser."
  :singleton t)

(cl-defmethod shared-initialize ((class xkb-ast-statement-parser) &rest _)
  "Static Constructor for `xkb-ast-statement-parser' CLASS."
  (oset class analyzer 'xkb-statement-lexer)
  (oset class start 'block))
#+end_src

#+begin_src emacs-lisp :tangle xkb-ast.el
(defclass xkb-ast-third-iteration-parser (xkb-ast-parser-spec) ()
  "Third Iteration Parser."
  :abstract t)
#+end_src

#+begin_src emacs-lisp :tangle xkb-ast.el
(defclass xkb-ast-keycode-block-parser (xkb-ast-third-iteration-parser eieio-singleton) ()
  "Keycode Block Parser - a Third Iteration Parser."
  :singleton t)

(cl-defmethod shared-initialize ((class xkb-ast-keycode-block-parser) &rest _)
  "Static Constructor for `xkb-ast-keycode-block-parser' CLASS."
  (oset class analyzer 'xkb-keycodes-block-lexer)
  (oset class start 'keycodes-block-statement))
#+end_src

** Wisent Tokens

The Wisent's parser uses a token form of =(TOKEN-CLASS VALUE [START . END])=, where ~VALUE~ can be of any valid Emacs Lisp data type.  This is slightly different from the =(TOKEN-CLASS START .END)= that Semantic uses and the default =wisent-lex= converts a Semantic token into a Wisent one by using the input buffer's substring as ~VALUE~.

I really prefer Wisent's style because it will allow us to use more complex regular expressions in the Lexer and use the token's ~VALUE~ to keep track of multiple match regions - or even to fully construct the AST Node in the Lexer.

The custom =xkb-wisent-lex= function supports such custom ~VALUE~ fields.

#+begin_src emacs-lisp
(define-wisent-lexer xkb-wisent-lex
  "Custom lexer."
  (let* ((token (car wisent-lex-istream))
         (node (car (cdr token))))
    (setq wisent-lex-istream (cdr wisent-lex-istream))
    (cons (semantic-lex-token-class token)
          (cons (cond ((not (eieio-object-p node)) nil)
                      ((xkb-ast-region-p node) node)
                      ((object-of-class-p node xkb-ast-node) node)
                      (t nil))
                (semantic-lex-token-bounds token)))))
#+end_src

Utility function to print a token.

#+begin_src emacs-lisp
(defun xkb-lex-print-token (token)
  "Pretty-prints Lexer TOKEN."
  (cond ((stringp token) token)
        ((consp token)
         (let* ((symbol (car token))
                (value (car (cdr token)))
                (bounds (semantic-lex-token-bounds token)))
           (if (and (eieio-object-p value) (object-of-class-p value xkb-ast-node))
               (cl-prin1-to-string value)
             (format "(%s %s)" symbol value))))
        (t (format "(TOKEN %s)" token))))
#+end_src

To fully construct an AST Node in the Lexer, we define an abstract base class.

#+begin_src emacs-lisp :tangle xkb-ast.el
(xkb-ast-define-ast-node lexer-node
                         :slots ((token :type symbol)
                                 (full-region :class region :print t))
                         :abstract t)
#+end_src

And a helper method.

#+begin_src emacs-lisp
(defmacro xkb-lex-push-token-node (node &rest blockspecs)
  "Push AST Node that has been constructed in the Lexer.

NODE is an AST Node of type `xkb-ast-lexer-node'.

We use it's 'token' and 'region' slots to construct
and push a token in the lexical analyzer token stream.

BLOCKSPECS will be passed to `semantic-lex-push-token'."
  `(with-slots (region token) ,node
     (cl-destructuring-bind (start . end) (xkb-ast-region-to-cons region))
     (semantic-lex-push-token
      (semantic-lex-token token start end ,node))
     ,blockspecs))
#+end_src

In most cases, we can simplify this.

#+begin_src emacs-lisp
(defmacro xkb-lex-push-simple-token-node (class group &rest ctor-args)
  "Push AST Node that has been constructed in the Lexer.

CLASS is the AST Node to be constructed (short name, ie. 'segment-name').

GROUP is the Regexp match group to be used for the :region slot.

CTOR-ARGS are additional arguments to be passed to the constructor."
  (let* ((class-name (intern (concat "xkb-ast-" (symbol-name class))))
         (token (intern (upcase (symbol-name class)))))
    `(let* ((group-cons (cons (match-beginning ,group) (match-end ,group)))
            (full-cons (cons (match-beginning 0) (match-end 0)))
            (node (funcall ,class-name
                           :region (xkb-ast-region group-cons)
                           :full-region (xkb-ast-region full-cons)
                           :token ',token ,@ctor-args)))
       (semantic-lex-push-token
        (semantic-lex-token ',token (car group-cons) (cdr group-cons) node))
       (setq semantic-lex-end-point (cdr full-cons)))))
#+end_src

* Syntax table.

The traditional Syntax Table is used by a few of the regular expression matches in the Lexer.

#+begin_src emacs-lisp
(defun xkb-mode-syntax-table (table &rest list)
  "Copy TABLE and set syntax for each element in LIST."
  (setq table (copy-syntax-table table))
  (while list
    (modify-syntax-entry (pop list) (pop list) table))
  table)

(defvar xkb-mode-syntax-table
  (xkb-mode-syntax-table (make-syntax-table)
                         ;; Comments start with a double slash.
                         ?/ "< 12c"
                         ?\n "> c"

                         ;; Mark double quotes as string delimiters.
                         ?\" "\""

                         ;; Make underscore a word constituent.
                         ?_ "w"

                         ;; Parenthesises
                         ?\{ "(}"
                         ?\{ "({"
                         ?\[ ")"
                         ?\] ")")
  "Syntax table for XKB buffers.")
#+end_src

* Debugging

Some utility functions for debugging.

#+begin_src emacs-lisp
(defvar xkb-debug-enabled t)

(defun xkb--text-at-point (&optional pos)
  "Return a formatted excerpt of text at POS; defaulting to `point'."
  (let* ((start (or pos (point)))
         (end (min (+ start 10) (point-max)))
         (text (buffer-substring-no-properties start end)))
    (format "%s:|%s|" start text)))

(defun xkb--debug (&rest args)
  "Debug print; apply `format' on ARGS and pass it to `message'.
Does nothing unless `xkb-debug-enabled'."
  (if xkb-debug-enabled
      (message (apply #'format args))))
#+end_src

Macro to wrap some function for debugging.

#+begin_src emacs-lisp
(defmacro xkb--install-debug (func)
  "Wrap FUNC in a debugging advice.
If FUNC is called while `xkb-debug-enabled', it's arguments and return
value will be dumped."
  (let* ((func-name (symbol-name func))
         (advice-name (make-symbol (concat "xkb--debug-advice-" func-name))))
    `(defadvice! ,advice-name (original &rest args)
       :around #',func
       (let ((start (point))
             (retval (apply original args)))
         (if xkb-debug-enabled
             (message (format "XKB DEBUG (%s - %s): %s -> %s - %s"
                              ,func-name args start (point) retval)))
         retval))))
#+end_src

* Lexer

** Utilities

Helper to construct =xkb-ast-region= from a match group.

#+begin_src emacs-lisp
(defsubst xkb-lex-match-region (group)
  "Construct `xkb-ast-region' from match group.

Use `match-beginning' and `match-end' on GROUP."
  (xkb-ast-region :start (match-beginning group) :end (match-end group)))
#+end_src

** Special Tokens

Macro to create a lexical analyzer for special tokens, such as symbols or an open or closing parenthesis.  The token will be looked up from the grammar, so these need to be declared in the header, for instance:

#+begin_src wisent-grammar :tangle no
%token <open-paren> LBRACE "{"
%token <close-paren> RBRACE "}"
#+end_src

#+begin_src emacs-lisp
(defmacro xkb-lex-special (name regexp type &rest forms)
  "Create lexical analyzer NAME to parse a symbol of type TYPE using REGEXP.

FORMS are evaluated upon a successful match BEFORE the new token is
created.  It is valid to ignore FORMS.
See `define-lex-analyzer' for more about analyzers."
  `(define-lex-analyzer ,name
     ,(concat "Try to parse a symbol of type '" type "'.")
     (looking-at ,regexp)
     ,@forms
     (let* ((key (match-string 0))
            (pos (match-beginning 0))
            (end (match-end 0))
            (symbol (semantic-lex-type-value ,type))
            (token (or (rassoc key (cdr symbol))
                       (error "No token of type '%s' found for symbol \"%s\"" ,type key))))
       (semantic-lex-push-token
	(semantic-lex-token (car token) pos end)))))
#+end_src

Opening and closing parentheses.

#+begin_src emacs-lisp
(xkb-lex-special wisent-xkb-lex-open-paren
  "\\s(" "open-paren"
  (setq semantic-lex-current-depth (1+ semantic-lex-current-depth)))

(xkb-lex-special wisent-xkb-lex-close-paren
  "\\s)" "close-paren"
  (setq semantic-lex-current-depth (1- semantic-lex-current-depth)))
#+end_src

For operators like for instance the equals sign, we explicitly match them in the regular expression, so we don't have to also mess around with the symbol table.

#+begin_src emacs-lisp
(xkb-lex-special wisent-xkb-lex-operator
  "[=;]" "operator")
#+end_src

** Newlines and Blank Lines

We do not really care about any newlines, except that we want to preserve any blank lines in the formatted output.  Since there shouldn't be any consecutive blank lines in the formatted output, we can already take care of that here and squash them into a single token.

#+begin_src emacs-lisp
(define-lex-regex-analyzer wisent-xkb-lex-newline
  "Detect and create newline tokens."
  "\\(\\s-*\n\\s-*\\)\\(\\s-*\n\\s-*\\)*"
  (when (match-beginning 2)
    (semantic-lex-push-token
     (semantic-lex-token 'BLANK-LINE (match-beginning 0) (match-end 0))))
  (setq semantic-lex-end-point (match-end 0)))
#+end_src

** Lexer Functions

All keywords need to be declared with =%keyword= in the grammar; any word that is not a keyword is an =IDENTIFIER=.  We allow dashes and underscores inside an identifier, but not at the start or end of it, nor do we allow multiple consecutive underscores or dashes.

#+begin_src emacs-lisp
(define-lex-regex-analyzer wisent-xkb-lex-identifier
  "Detect and create identifier or keyword tokens."
  "\\([[:alnum:]]+[_-]\\)*[[:alnum:]]+"
  (semantic-lex-push-token
   (semantic-lex-token
    (or (semantic-lex-keyword-p (match-string 0))
        'IDENTIFIER)
    (match-beginning 0)
    (match-end 0))))
#+end_src

** Digits

#+begin_src emacs-lisp :tangle xkb-ast.el
(xkb-ast-define-ast-node digit
                         :base-class lexer-node
                         :no-grammar-macro t
                         :slots ((value :type string :print t)))
#+end_src

#+begin_src emacs-lisp
(define-lex-regex-analyzer wisent-xkb-lex-digit
  "Match a digit."
  "[[:digit:]]+"
  (let ((value (buffer-substring-no-properties (match-beginning 0) (match-end 0))))
    (xkb-lex-push-simple-token-node digit 0 :value value)))
#+end_src

** Keycode

Match a ~<KEY>~ literal.

#+begin_src emacs-lisp :tangle xkb-ast.el
(xkb-ast-define-ast-node keycode
                         :base-class lexer-node
                         :no-grammar-macro t
                         :slots ((keycode :type string :print t))
                         :decorate
                         '((((class color) (min-colors 88) (background light)) (:foreground "Blue1"))
                           (((class color) (min-colors 88) (background dark)) (:foreground "LightSkyBlue"))
                           (((class color) (min-colors 16) (background light)) (:foreground "Blue"))
                           (((class color) (min-colors 16) (background dark)) (:foreground "LightSkyBlue"))
                           (((class color) (min-colors 8)) (:foreground "blue" :bold t))
                           (t (:bold t))))
#+end_src

#+begin_src emacs-lisp
(define-lex-regex-analyzer wisent-xkb-lex-keycode
  "Match a <KEYCODE>."
  "<\\([[:digit:]A-Za-z]+\\)>"
  (let ((code (buffer-substring-no-properties (match-beginning 1) (match-end 1))))
    (xkb-lex-push-simple-token-node keycode 0 :keycode code)))
#+end_src

** Section Name

Strings are more like variable names in our grammar, so we need to restrict them a bit.

#+begin_src emacs-lisp :tangle xkb-ast.el
(xkb-ast-define-ast-node section-name
                         :base-class lexer-node
                         :no-grammar-macro t
                         :slots ((full-region :class region :print t)
                                 (name :type string :print t))
                         :decorate font-lock-function-name-face)
#+end_src

#+begin_src emacs-lisp
(define-lex-regex-analyzer wisent-xkb-lex-section-name
  "Match a stringified section name"
  "\"\\([[:alnum:]\s_-]+\\)\""
  (let ((name (buffer-substring-no-properties (match-beginning 1) (match-end 1))))
    (xkb-lex-push-simple-token-node section-name 1 :name name)))
#+end_src

** Abstract Node Declarations

We use ~block-statement~ as an abstract base class that will be used in both the Second as well as the Third Iteration.

#+begin_src emacs-lisp :tangle xkb-ast.el
(xkb-ast-define-ast-node block-statement
                         :abstract t)
#+end_src

#+begin_src emacs-lisp :tangle xkb-ast.el
(xkb-ast-define-ast-node block
                         :slots ((statements
                                  :list-class block-statement
                                  :indent t)))

(xkb-ast-define-ast-node statement
                         :base-class block-statement
                         :slots ((code-comment
                                  :maybe-class code-comment)))
#+end_src

All comment and syntax error statements share a common abstract ~comment-statement~ base class.

#+begin_src emacs-lisp :tangle xkb-ast.el
(xkb-ast-define-ast-node comment-statement
                         :base-class block-statement
                         :abstract t)
#+end_src

** Comments

We distinguish between a couple different comment types:

- ~BABEL-START-COMMENT~ and ~BABEL-END-COMMENT~ are those that have been automatically created by =org-babel-tangle=.  These need to be preserved in the AST to allow the code formatter to reformat the document in a way where it can still be re-read via =org-babel-detangle= to update the Org Mode document it was created from.

- ~FULL-LINE-COMMENT~ is any comment that is on a line by itself.

- ~CODE-COMMENT~ is a comment that's at the end of a line, after a statement.

For all of these different comments, we construct the AST Node here in the Lexer to have full flexibility over properly recording the code regions for both syntax-highlighting as well as code reformatting.

This also allows us to put all of the common parts into an abstract base class.  We use multiple inheritance here because our grammar expects all comments to be a subclass of ~comment-statement~ - which also includes blank lines and syntax errors - and =xkb-wisent-lex= expects a subclass of ~lexer-node~.

#+begin_src emacs-lisp :tangle xkb-ast.el
(xkb-ast-define-ast-node lexer-comment-statement
                         :base-class (lexer-node comment-statement)
                         :slots ((full-region :class region :print t))
                         :extra-decorations ((full-region . font-lock-comment-face))
                         :abstract t)

(xkb-ast-define-ast-node full-line-comment
                         :base-class lexer-comment-statement
                         :decorate font-lock-doc-face
                         :no-grammar-macro t)

(xkb-ast-define-ast-node code-comment
                         :base-class lexer-comment-statement
                         :decorate font-lock-string-face
                         :no-grammar-macro t)

(xkb-ast-define-ast-node babel-start-comment
                         :base-class lexer-comment-statement
                         :decorate font-lock-doc-markup-face
                         :no-grammar-macro t)

(xkb-ast-define-ast-node babel-end-comment
                         :base-class lexer-comment-statement
                         :decorate font-lock-comment-face
                         :no-grammar-macro t)
#+end_src

This regular expression looks a bit ugly - it has three match groups and we check whether we are at the beginning of the line to distinguish between a ~full-line-comment~ and a ~code-comment~.

#+begin_src emacs-lisp
(define-lex-regex-analyzer wisent-xkb-lex-comment
  "Match a comment."
  "\\s-*//\\s-*\\(?:\\[\\[file:.*?\\]\\[\\(.*\\)\\]\\]$\\|\\(.* ends here\\)\\|\\(.*\\)\\)"
  (cond ((match-beginning 1) (xkb-lex-push-simple-token-node babel-start-comment 1))
        ((match-beginning 2) (xkb-lex-push-simple-token-node babel-end-comment 2))
        ((bolp) (xkb-lex-push-simple-token-node full-line-comment 3))
        (t (xkb-lex-push-simple-token-node code-comment 3))))
#+end_src

** Blocks

#+begin_src emacs-lisp
(define-lex-block-analyzer wisent-xkb-lex-block
  "XKB block lexer."
  (BRACE-BLOCK ("{" LBRACE) ("}" RBRACE)))
#+end_src

** Recursively called Block Lexer

#+begin_src emacs-lisp
(define-lex-regex-analyzer wisent-xkb-lex-statement
  "Match any abstract statement."
  "\\(\.+?\\);"
  (semantic-lex-push-token
     (semantic-lex-token 'STATEMENT (match-beginning 1) (match-end 1)))
  (setq semantic-lex-end-point (match-end 0)))
#+end_src

** Error Handling

Print some more useful error messages.

#+begin_src emacs-lisp
(define-lex-analyzer wisent-xkb-lex-default-action
  "The default action when no other lexical actions match text.
This action will just throw an error."
  t
  (let* ((begin (car semantic-lex-analysis-bounds))
         (look-ahead (xkb--text-at-point begin))
         (msg (format "Unmatched Text during Lexical Analysis: %s - %ss" semantic-lex-analysis-bounds look-ahead)))
    (xkb--debug (concat "ERROR: " msg))
    (error msg)))

#+end_src

** Lexer Definition

This is our regular lexer.

#+begin_src emacs-lisp
(define-lex xkb-lex
  "Main Lexer."
  semantic-lex-ignore-whitespace
  wisent-xkb-lex-comment
  wisent-xkb-lex-newline
  wisent-xkb-lex-identifier
  wisent-xkb-lex-section-name
  wisent-xkb-lex-block
  wisent-xkb-lex-operator
  wisent-xkb-lex-default-action)
#+end_src

Special lexer that is called recursively to expand blocks into statements.

#+begin_src emacs-lisp
(define-lex xkb-statement-lexer
  "Lexer to expand Blocks into Statements."
  semantic-lex-ignore-whitespace
  wisent-xkb-lex-comment
  wisent-xkb-lex-newline
  wisent-xkb-lex-statement
  wisent-xkb-lex-default-action)
#+end_src

Third iteration lexer.

#+begin_src emacs-lisp
(define-lex xkb-keycodes-block-lexer
  "Third iteration lexer for 'xkb-keycodes' blocks."
  semantic-lex-ignore-whitespace
  wisent-xkb-lex-digit
  wisent-xkb-lex-identifier
  wisent-xkb-lex-keycode
  wisent-xkb-lex-operator
  wisent-xkb-lex-default-action)
#+end_src

* Grammar

** First Iteration

*** Root Node and Start

The First Iteration uses ~first-iteration-start~ as it's start symbol and it will return an instance of =xkb-ast-first-iteration-root=.

#+begin_src emacs-lisp :tangle xkb-ast.el
(xkb-ast-define-ast-node first-iteration-root
                         :slots ((keycodes-block
                                  :class raw-keycodes-block
                                  :indent t)))
#+end_src

In our grammar, we currently only support one of the three file types, so we just hard-code it there for the moment.

#+begin_src wisent-grammar
first-iteration-start: keycodes-block
                       (FIRST-ITERATION-ROOT $1);
#+end_src

*** Generic Block Definitions

First, we need to create some generic definitions.  The =xkb-ast-define-ast-node= defines both the class as well as the macro function to use in the grammar.

#+begin_src emacs-lisp :tangle xkb-ast.el
(xkb-ast-define-ast-node keyword
                         :decorate font-lock-keyword-face)

(xkb-ast-define-ast-node builtin
                         :decorate font-lock-builtin-face)
#+end_src

*** Key-Code Block

Here, we use the =xkb-ast-define-ast-node= macro to create the ~raw-keycodes-block~ class that has already been referenced above and a ~RAW-KEYCODES-BLOCK~ grammar macro to construct an instance of it.

#+begin_src emacs-lisp :tangle xkb-ast.el
(xkb-ast-define-ast-node raw-keycodes-block
                         :slots ((keyword :class keyword :print t)
                                 (name :class section-name :print t)
                                 (block-region :class region)))
#+end_src

In our grammar rule, the ~XKB-KEYCODES~ token matches the =xkb_keycodes= keyword and ~BRACE-BLOCK~ is a generic block enclosed in curly braces. As a First Iteration rule, the lexer won't actually look at what's inside that block - when it encounters the opening curly brace, it will simply look for a "matching" closing one and wrap up everything that's between in that token.

Wisent will return an instance of the ~raw-keycodes-block~ class for this rule, which will be expanded in the Second Iteration.

#+begin_src wisent-grammar
keycodes-block: XKB-KEYCODES (KEYWORD :region $1)
                SECTION-NAME
                BRACE-BLOCK
                SEMICOLON
                (RAW-KEYCODES-BLOCK $2 $3 (EXPAND-REGION $4));
#+end_src

** Second Iteration

*** Grammar Declaration

Our lexer does not only distinguish between a single newline character and a blank line,  it also detects multiple consecutive blank lines and only returns a single =BLANK-LINE= token for them.

In this parsing iteration, a =STATEMENT= is anything (that is not either a comment or a blank line) that is followed by a semicolon.  It can optionally be followed by a =CODE-COMMENT=.

#+begin_src wisent-grammar
block: block-statement
       (BLOCK (cons $1 nil))
     | block-statement block
       (BLOCK (cons $1 (oref $2 statements)));


block-statement: BLANK-LINE (BLANK-LINE)
               | FULL-LINE-COMMENT
               | BABEL-START-COMMENT
               | BABEL-END-COMMENT
               | STATEMENT
                 (STATEMENT :region $1)
               | STATEMENT CODE-COMMENT
                 (STATEMENT :region $1 :code-comment $2)
               | syntax-error;
#+end_src

Error recovery.

#+begin_src wisent-grammar
syntax-error: error
              (let ((tag (SYNTAX-ERROR :region $1)))
                (wisent-clearin)
                (wisent-skip-token)
                tag);
#+end_src

*** Comments and Syntax Errors

#+begin_src emacs-lisp :tangle xkb-ast.el
(xkb-ast-define-ast-node syntax-error
                         :base-class comment-statement
                         :decorate
                         '((default :weight bold)
                           (t :foreground "#CC6666")))

(xkb-ast-define-ast-node blank-line :base-class comment-statement)
#+end_src

** Third Iteration

#+begin_src wisent-grammar
keycodes-block-statement: keycode-minimum
                        | keycode-maximum
                        | keycode-assign
                        | syntax-error;
#+end_src

*** Key-Code Definition

Match a key-code definition like the following:

#+begin_example
<ESC> = 9;
#+end_example

We create the following tags:

- A ~keycode~ tag representing the =ESC=  literal.  Whether we include its surrounding brackets is a matter of taste and controlled by the lexer; this will only affect syntax highlighting.
- A ~keycode-value~ tag representing the key's numerical value - in our case =9=.
- A ~keycode-assign~ tag that includes all of the above via =:keycode= and =:value= attributes.

#+begin_src emacs-lisp :tangle xkb-ast.el
(xkb-ast-define-ast-node keycode-value
                         :base-class digit
                         :decorate
                         '((((class color) (min-colors 88) (background light)) (:foreground "DarkGreen"))
                           (((class color) (min-colors 88) (background dark)) (:foreground "PaleGreen"))
                           (((class color) (min-colors 8)) (:foreground "green"))
                           (t (:bold t :italic t))))
#+end_src

*** Keycode Statements

We define an abstract base class for the Third Iteration Nodes.

#+begin_src emacs-lisp :tangle xkb-ast.el
(xkb-ast-define-ast-node keycode-statement-base
                         :base-class block-statement
                         :abstract t)
#+end_src

These are all the actual code statements.

#+begin_src emacs-lisp :tangle xkb-ast.el
(xkb-ast-define-ast-node keycode-minimum
                         :base-class keycode-statement-base
                         :slots ((minimum :class builtin :print t)
                                 (value :class keycode-value :print t)))

(xkb-ast-define-ast-node keycode-maximum
                         :base-class keycode-statement-base
                         :slots ((maximum :class builtin :print t)
                                 (value :class keycode-value :print t)))

(xkb-ast-define-ast-node keycode-assign
                         :base-class keycode-statement-base
                         :slots ((code :class keycode :print t)
                                 (value :class keycode-value :print t)))
#+end_src

In addition to those, we also need to pass-through all the comments.

#+begin_src emacs-lisp :tangle xkb-ast.el
(xkb-ast-define-ast-node keycode-statement-or-comment
                         :base-class keycode-statement-base
                         :abstract t)
#+end_src

#+begin_src emacs-lisp :tangle xkb-ast.el
(xkb-ast-define-ast-node keycode-comment
                         :base-class keycode-statement-or-comment
                         :slots ((comment
                                  :class comment-statement
                                  :indent t)))

(xkb-ast-define-ast-node keycode-statement
                         :base-class keycode-statement-or-comment
                         :slots ((statement
                                  :class keycode-statement-base
                                  :indent t)
                                 (comment
                                  :maybe-class code-comment
                                  :indent t)))
#+end_src

#+begin_src wisent-grammar
keycode-minimum: MINIMUM (BUILTIN)
                 EQUALS
                 DIGIT (EXPAND-SUBCLASS keycode-value $4 (value))
                 (KEYCODE-MINIMUM $2 $5);

keycode-maximum: MAXIMUM (BUILTIN)
                 EQUALS
                 DIGIT (EXPAND-SUBCLASS keycode-value $4 (value))
                 (KEYCODE-MAXIMUM $2 $5);

keycode-assign: KEYCODE
                EQUALS
                DIGIT (EXPAND-SUBCLASS keycode-value $3 (value))
                (KEYCODE-ASSIGN $1 $4);
#+end_src

* Wisent

#+begin_src emacs-lisp
(defun xkb-setup-wisent ()
  "Setup Wisent in current buffer."
  (wisent-xkb-wy--install-parser)
  (global-semanticdb-minor-mode -1)
  (setq semantic-lex-analyzer 'xkb-lex
        semantic-lex-syntax-table xkb-mode-syntax-table
        wisent-verbose-flag t))
#+end_src

* Lexer and Parser

** Abstract Parser Base Class

We can reuse some of these slots in the parser, so we use a common abstract base class for both.

#+begin_src emacs-lisp :tangle xkb-ast.el
(defclass xkb-ast-abstract-parser ()
  ((region :type xkb-ast-region
           :initarg :region
           :initform (funcall #'xkb-ast-region)
           :documentation "The region to operate on.")
   (parser-spec :type xkb-ast-parser-spec
                :initarg :parser-spec
                :documentation "AST Parser to use.")
   (pretty-token :type (or null string)
                 :initarg :pretty-token :initform nil
                 :documentation "When called recursively, pretty-printed name of current token.
This argument is just for cosmetic purposes."))
  "Abstract base class for the Lexer and Parser."
  :abstract t)
#+end_src

** Lexer

#+begin_src emacs-lisp :tangle xkb-ast.el
(defclass xkb-ast-lexer (xkb-ast-abstract-parser)
  ((recursive :type boolean
              :initarg :recursive
              :initform nil
              :documentation "Whether to recursively expand block tokens.")
   (depth :type (or null integer)
          :initarg :depth
          :initform nil
          :documentation "To be passed to `semantic-lex-region'.")
   (running-recursively :type (or null integer)
                        :initarg :running-recursively
                        :initform nil
                        :documentation "Whether we are running recursively.
Internal use only."))
  "AST Lexer.")
#+end_src

#+begin_src emacs-lisp
(cl-defgeneric xkb-ast-lexer-run (lexer context)
  "Generic AST Lexer main entry point.

Run the AST Lexer LEXER, using CONTEXT for status and error reporting.")

(cl-defgeneric xkb-ast-lexer--print-result (lexer context token-stream)
  "Generic result reporting function.

When running the LEXER in an Interactive CONTEXT, display the
result TOKEN-STREAM in a buffer.")
#+end_src

Default implementation.

#+begin_src emacs-lisp
(cl-defgeneric xkb-ast-lexer--print-result (_ context token-stream)
  "In the default CONTEXT, we simply print the TOKEN-STREAM."
  (xkb-ast-context-print context "AST Lexer Result: %s" token-stream))

(cl-defmethod xkb-ast-lexer-run ((lexer xkb-ast-lexer) context)
  "LEXER main entry point, using CONTEXT for status and error reporting."
  (with-slots (region recursive depth) lexer
    (xkb-ast-with-error-handler
     context
     (cl-flet ((lex-region ()
                           (with-slots (start end) region
                             (let* ((parser (oref lexer parser-spec))
                                    (semantic-lex-analyzer (oref parser analyzer)))
                               (xkb-ast-with-region region (semantic-lex start end depth)))))
               (inner-block-region (range)
                                   (xkb-ast-region :start (+ (car range) 1) :end (- (cdr range) 1)))
               (recursive-lexer (inner-region token spec)
                                (let* ((current (or (oref lexer running-recursively) 0))
                                       (recursion (+ current 1)))
                                  (clone lexer
                                         :region inner-region
                                         :parser-spec spec
                                         :running-recursively recursion
                                         :pretty-token (xkb-lex-print-token token)))))
       (let ((token-stream (lex-region)))
         (xkb-ast-lexer--print-result lexer context token-stream)
         (mapcar
          (lambda (token)
            (cl-destructuring-bind (key . range) token
              (cond
               ((not recursive) token)
               ((eq key 'BRACE-BLOCK)
                (xkb-ast-lexer-run (recursive-lexer (inner-block-region range) "BLOCK"
                                                    (xkb-ast-statement-parser))
                                   context))
               ((eq key 'STATEMENT)
                (xkb-ast-lexer-run (recursive-lexer (xkb-ast-region range) "STATEMENT"
                                                    (xkb-ast-keycode-block-parser))
                                   context))
               (t token))))
          token-stream))))))
#+end_src

** Interactive Lexer

#+begin_src emacs-lisp
(cl-defmethod xkb-ast-lexer--print-result
  :around (this (context xkb-ast-interactive-context) token-stream)
  "In Interactive CONTEXT, we nicely format the TOKEN-STREAM."
  (with-slots (region pretty-token running-recursively) this
    (let ((separator (oref-default context separator))
          (pretty-region (cl-prin1-to-string region)))
      (if running-recursively
          (xkb-ast-context-print context "\nRecursive Result (iteration %s) for %s in %s:\n%s"
                                 running-recursively pretty-token pretty-region separator)
        (xkb-ast-context-print context "\nMain LEX result:\n%s" separator))
      (xkb-ast-context-print context "%s\n%s\n"
                             (mapconcat #'xkb-lex-print-token token-stream "\n")
                             separator))))

(cl-defmethod xkb-ast-lexer-run
  :around (this (context xkb-ast-interactive-context))
  "Interactive CONTEXT overload for lexer THIS."
  (with-slots (region pretty-token running-recursively) this
    (let ((separator (oref-default context separator))
          (pretty-region (cl-prin1-to-string region)))
      (cond (running-recursively
             (xkb-ast-context-print context "\n%s TOKEN (iteration %s): %s"
                                    pretty-token running-recursively pretty-region))
            (pretty-token
             (xkb-ast-context-print context "Lexing Token %s at %s"
                                    pretty-token pretty-region))
            (t
             (xkb-ast-context-print context "Main LEX pass.")))
      (let ((result (cl-call-next-method)))
        (cond (running-recursively
               (xkb-ast-context-print context "\n%s TOKEN (iteration %s) DONE: %s"
                                      pretty-token running-recursively pretty-region))
              (pretty-token
               (xkb-ast-context-print context "\nLexing Token %s done at %s"
                                      pretty-token pretty-region))
              (t
               (xkb-ast-context-print context "\nMain LEX pass complete:\n%s" result)))
        (xkb-ast-context-print context "%s\n\n" separator)
        result))))
#+end_src

** Parser

#+begin_src emacs-lisp
(defclass xkb-ast-parser (xkb-ast-abstract-parser) ()
  "AST Parser.")
#+end_src

#+begin_src emacs-lisp
(cl-defmethod xkb-ast-parser-run ((this xkb-ast-parser) (context xkb-ast-context))
  "Run AST Parser THIS in CONTEXT.

Run a single parser iteration, using CONTEXT for progress reporting and
debug output."
  (with-slots (parser-spec region) this
    (cl-macrolet
        ((wrap-print (text form)
                     `(progn
                        (xkb-ast-context-print context ,text)
                        (let ((result ,form))
                          (xkb-ast-context-print context "%s DONE: %s"
                                                 ,text (cl-prin1-to-string result))
                          result)))
         (wrap-region (body) `(xkb-ast-with-region region ,body))
         (wrap-inner (body &rest args)
                     `(xkb-ast-with-error-handler context (wrap-region ,body) ,@args)))
      (cl-flet*
          ((lexing-error (msg)
                         (xkb-ast-context-error context "PARSING FAILED IN LEXER" msg))
           (parser-error (msg)
                         (xkb-ast-context-error context "PARSER ERROR: %s - %s" msg wisent-input))
           (run-lexer ()
                      (let ((lexer (xkb-ast-lexer
                                    :parser-spec parser-spec
                                    :region region
                                    :recursive nil)))
                        (wrap-inner
                         (xkb-ast-lexer-run lexer context)
                         :error-handler #'lexing-error)))
           (run-parser (input)
                       (wrap-inner
                        (let* (;; (wisent-recovering t)
                               (wisent-lex-istream input))
                          (wisent-parse wisent-xkb-wy--parse-table
                                        #'xkb-wisent-lex
                                        #'parser-error
                                        (oref parser-spec start))))))
        (xkb-ast-context-print context "PARSER RUN: %s"
                               (cl-prin1-to-string this))
        (let* ((token-stream (wrap-print "RUN LEXER" (run-lexer)))
               (output (wrap-print "RUN PARSER" (run-parser token-stream))))
          (xkb-ast-context-print context "PARSER DONE: %s"
                                 (cl-prin1-to-string output))
          output)))))
#+end_src

* Second Iteration

We can now define the Second Iteration as an AST Traversal.  The =xkb-ast-second-iteration= class is used to specialize on.

#+begin_src emacs-lisp
(defclass xkb-ast-second-iteration (xkb-ast-visitor) ())
#+end_src

We will transform the ~first-iteration-root~ Node into a new ~second-iteration-root~ Node, replacing ~raw-keycodes-block~ with ~keycodes-block-second-iteration~.

#+begin_src emacs-lisp
(xkb-ast-define-ast-node second-iteration-root
                         :slots ((keycodes-block
                                  :class keycodes-block-second-iteration
                                  :indent t)))

(xkb-ast-define-ast-node keycodes-block-second-iteration
                         :slots ((keyword :class keyword :indent t)
                                 (name :class section-name :indent t)
                                 (block :class block :indent t)))
#+end_src

Since I already feel like I've been writing far too much boilerplate code, let's introduce some macro.

#+begin_src emacs-lisp
(cl-defmacro xkb-ast-define-traversal (visitor-type node-type &body body)
  "Create `xkb-ast-traverse' specialization.

VISITOR-TYPE is the `xkb-ast-visitor' subclass.
NODE-TYPE is the `xkb-ast-node' subclass.

BODY in the body of the generated method."
  (let* ((visitor-name (concat "xkb-ast-" (symbol-name visitor-type)))
         (node-name (concat "xkb-ast-" (symbol-name node-type)))
         (docstring (concat "Specialized AST Traversal.\n\n"
                            "VISITOR is the AST Visitor, specialized on `" visitor-name "'.\n"
                            "NODE is the AST Node, specialized on `" node-name "'.\n"
                            "CONTEXT is the `xkb-ast-context' for diagnostics and status.")))
    `(cl-defmethod xkb-ast-traverse
       (context (visitor ,(intern visitor-name)) (node ,(intern node-name)))
       ,docstring
       ,@body)))
#+end_src

The main traversal.

#+begin_src emacs-lisp
(xkb-ast-define-traversal
 second-iteration first-iteration-root
 (let ((output (xkb-ast-traverse context visitor (oref node keycodes-block))))
   (cond ((null output)
          nil)
         ((xkb-ast-keycodes-block-second-iteration-p output)
          (xkb-ast-second-iteration-root :region (oref node region)
                                         :keycodes-block output))
         (t (error "Got invalid output: %s" (type-of output))))))
#+end_src

#+begin_src emacs-lisp
(xkb-ast-define-traversal
 second-iteration raw-keycodes-block
 (let* ((block-region (oref node block-region))
        (inner-region (xkb-ast-region :start (+ (oref block-region start) 1)
                                      :end (- (oref block-region end) 1)))
        (parser (xkb-ast-parser :parser-spec (xkb-ast-statement-parser)
                                :region inner-region))
        (output (xkb-ast-parser-run parser context)))
   (with-slots (region keyword name) node
     (xkb-ast-keycodes-block-second-iteration :region region
                                              :keyword keyword
                                              :name name
                                              :block output))))
#+end_src

* Third Iteration

The Third Iteration is handled in a very similar way; we use the =xkb-ast-third-iteration= class here to specialize on.

#+begin_src emacs-lisp
(defclass xkb-ast-third-iteration (xkb-ast-visitor) ())
#+end_src

We will transform the ~second-iteration-root~ Node into a new ~third-iteration-root~ Node, replacing ~keycodes-block-second-iteration~ with actual Nodes.

#+begin_src emacs-lisp
(xkb-ast-define-ast-node third-iteration-root
                         :slots ((keycodes-block
                                  :class keycodes-block
                                  :indent t)))

(xkb-ast-define-ast-node keycodes-block
                         :slots ((keyword :class keyword)
                                 (name :class section-name)
                                 (statements
                                  :list-class keycode-statement-or-comment
                                  :indent t)))
#+end_src

The main traversal.

#+begin_src emacs-lisp
(xkb-ast-define-traversal
 third-iteration second-iteration-root
 (with-slots (region keycodes-block) node
   (let ((output (xkb-ast-traverse context visitor keycodes-block)))
     (xkb-ast-third-iteration-root :region region :keycodes-block output))))
#+end_src

Keycodes block.

#+begin_src emacs-lisp
(xkb-ast-define-traversal
 third-iteration keycodes-block-second-iteration
 (with-slots (region keyword name block) node
   (let* ((output (xkb-ast-traverse context visitor block)))
     (xkb-ast-context-print context "THIRD ITERATION KEYCODES BLOCK: %s"
                            (cl-prin1-to-string output))
     (xkb-ast-keycodes-block :region region :keyword keyword
                             :name name :statements output))))
#+end_src

This is now an abstract ~block~, we need to keep track of the current context prior the getting here.

#+begin_src emacs-lisp
(xkb-ast-define-traversal
  third-iteration block
  (with-slots (statements) node
    (mapcar (apply-partially #'xkb-ast-traverse context visitor) statements)))
#+end_src

Wrap-up all comments.

#+begin_src emacs-lisp
(xkb-ast-define-traversal
 third-iteration comment-statement
 (xkb-ast-keycode-comment :region (oref node region) :comment node))
#+end_src

Main parser.

#+begin_src emacs-lisp
(xkb-ast-define-traversal
 third-iteration statement
 (xkb-ast-context-print context "REGULAR STATEMENT: %s" (cl-prin1-to-string node))
 (let* ((block-region (oref node region))
        (parser (xkb-ast-parser :parser-spec (xkb-ast-keycode-block-parser)
                                :region block-region))
        (output (xkb-ast-parser-run parser context)))
   (xkb-ast-context-print context "THIRD ITERATION STATEMENT: %s"
                          (cl-prin1-to-string output))
   (cond ((xkb-ast-syntax-error-p output)
          (xkb-ast-keycode-comment :region (oref output region) :comment output))
         (t (let ((statement (xkb-ast-keycode-statement :region (oref output region) :statement output)))
              (when (slot-boundp node 'code-comment)
                (oset statement comment (oref node code-comment)))
              statement)))))
#+end_src

* Decorations

Once we got a full AST, we can add decorations with an AST Visit.

#+begin_src emacs-lisp
(cl-defmethod xkb-ast-add-decorations ((context xkb-ast-context) (root xkb-ast-third-iteration-root))
  "Add decorations to AST Root Node ROOT.

CONTEXT is used for debugging and diagnostics."
  (xkb-ast-context-print context "DECORATIONS: %s" (type-of root))
  (cl-flet ((create-decoration (decoration)
                               (with-slots (region face) decoration
                                 (let ((overlay (make-overlay (oref region start) (oref region end))))
                                   (overlay-put overlay 'face face)))))
    (let ((visitor (xkb-ast-decoration-visitor)))
      (xkb-ast-visit context visitor root)
      (delete-all-overlays)
      (with-slots (decorations) visitor
        (mapc #'create-decoration decorations)))))
#+end_src

* Code Formatter

One of the great advantages of having a fully type-safe AST is that we can use it to reformat the code.  We implement it as an AST Visit, using =xkb-ast-code-formatter=.

#+begin_src emacs-lisp
(defclass xkb-ast-code-formatter (xkb-ast-visitor)
  ((output :initform nil)))
#+end_src

Collecting output.

#+begin_src emacs-lisp
(cl-defmethod xkb-ast-formatter-write ((this xkb-ast-code-formatter) (msg-or-fmt string) &rest args)
  "Add text to `xkb-ast-code-formatter' THIS.

If the optional ARGS argument is present, then MSG-OR-FMT will
be interpreted as a `format' specifier.

Otherwise, it is the string to be printed."
  (with-slots (output formatter) this
    (let ((formatted (apply #'xkb-ast--format-maybe-args nil msg-or-fmt args)))
      (setq output (cons formatted output)))))
#+end_src

It is quite similar to how we added decorations, except that we'll need to write a few specializations.

#+begin_src emacs-lisp
(cl-defmethod xkb-ast-run-formatter ((context xkb-ast-context) (root xkb-ast-third-iteration-root))
  "Format AST Node ROOT.

CONTEXT is used for debugging and diagnostics."
  (xkb-ast-context-print context "CODE FORMATTER: %s" (type-of root))
  (let ((visitor (xkb-ast-code-formatter))
        (separator (oref-default context separator)))
    (xkb-ast-visit context visitor root)
    (xkb-ast-context-print context "\n\nCODE FORMATTER DONE.\n%s\s" separator)
    (with-slots (output) visitor
      (setq output (nreverse output))
      (let ((result (mapconcat #'identity output "")))
        (xkb-ast-context-print context "%s\n%s\n" result separator)))))
#+end_src

Let's first write some helper macro.

#+begin_src emacs-lisp
(cl-defmacro xkb-ast-define-formatter (node-type qualifiers &body body)
  "Create `xkb-ast-visit' specialization for Code Formatting.

NODE-TYPE is the `xkb-ast-node' subclass.

QUALIFIERS is passed to `cl-defmethod'.

BODY in the body of the generated method."
  (let* ((node-name (concat "xkb-ast-" (symbol-name node-type)))
         (docstring (concat "Specialized AST Visit for Code Formatting.\n\n"
                            "VISITOR is the `xkb-ast-code-formatter' visitor.\n"
                            "NODE is the AST Node, specialized on `" node-name "'.\n"
                            "CONTEXT is the `xkb-ast-context' for diagnostics and status.")))
    `(cl-defmethod xkb-ast-visit ,qualifiers
       ((context xkb-ast-context) (this xkb-ast-code-formatter) (node ,(intern node-name)))
       ,docstring
       ,@body)))
#+end_src

Alright, ~keycodes-block~ is the outer block.

#+begin_src emacs-lisp
(xkb-ast-define-formatter
 keycodes-block :around
 (with-slots (keyword name) node
   (xkb-ast-formatter-write this "xkb_keycodes \"%s\" {\n" (oref name name))
   (cl-call-next-method)
   (xkb-ast-formatter-write this "};")))
#+end_src

#+begin_src emacs-lisp
(xkb-ast-define-formatter
 keycode-assign :around
 (with-slots (code value) node
   (xkb-ast-formatter-write this "    <%s> = %s;\n"
                            (oref code keycode)
                            (oref value value))))
#+end_src

* Major Mode

** Utility Macro

#+begin_src emacs-lisp
(defmacro xkb--run-interactively (command name init-forms body)
  "Utility macro to run a command interactively.

Create new output buffer NAME and `xkb-ast-interactive-context' to
redirect all diagnostic messages to that buffer.

COMMAND is the pretty-printed, user-visible name of the command,
to be used in error messages.

First lexically bind INIT-FORMS via `let*' with the current buffer,
then evaluate BODY and display the output in the special buffer."
  `(let* ((context (xkb-ast-interactive-context))
          (alist '((dedicated . t)
                   (side . right)
                   (window-parameters . ((mode-line-format . none))))))
     (with-temp-buffer-window ,name `(display-buffer-in-side-window ,@alist)
                              (lambda (window result)
                                (select-window window t)
                                (select-frame-set-input-focus (selected-frame))
                                (with-current-buffer (window-buffer)
                                  (help-mode)
                                  (+word-wrap-mode t))
                                result)
       (xkb-ast-with-error-handler
        context
        (let* (,@init-forms)
          (let ((result ,body))
            (xkb-ast-context-print context "RESULT: %s"
                                   (cl-prin1-to-string result))))
        :error-handler (lambda (error-message)
                         (message "Unhandled exception in interactive command %s: %s"
                                  ,command error-message))))))
#+end_src

** Interactive Lexer

#+begin_src emacs-lisp
(defun xkb-lex-buffer (&optional arg)
  "Interactively run the AST Lexer.

Runs the AST Lexer with diagnostics enabled and prints it's output
into a dedicated buffer.

The optional ARG is passed to `semantic-lex' as its DEPTH argument."
  (interactive "P")
  (xkb--run-interactively
   "`xkb-lex-buffer'" "*XKB Lexer*"
   ((lexer (xkb-ast-lexer :parser-spec (xkb-ast-first-iteration-parser)
                          :recursive t
                          :depth (if arg (prefix-numeric-value arg)))))
   (xkb-ast-lexer-run lexer context)))
#+end_src

** Interactive Parser

#+begin_src emacs-lisp
(defun xkb-parse-buffer ()
  "Interactively run the AST Parser.

Runs the AST Parser with diagnostics enabled and prints it's output
into a dedicated buffer."
  (interactive)
  (xkb--run-interactively
   "`xkb-parse-buffer'" "*XKB Parser*"
   ((parser (xkb-ast-parser :parser-spec (xkb-ast-first-iteration-parser)))
    (separator (oref-default context separator))
    (visitor (xkb-ast-visitor)))
   (let ((output (xkb-ast-parser-run parser context)))
     (xkb-ast-context-print context "%s\n" separator)
     (cond ((null output)
            (xkb-ast-context-error context "PARSING FAILED"))
           ((xkb-ast-first-iteration-root-p output)
            (xkb-ast-context-print context "\nGOT ROOT BLOCK\n%s" separator)
            (xkb-ast-visit context visitor output)
            (xkb-ast-context-print context "%s\n\n" separator)
            (let ((second-iteration
                   (xkb-ast-traverse context (xkb-ast-second-iteration) output)))
              (xkb-ast-context-print context "SECOND ITERATION DONE: %s"
                                     (cl-prin1-to-string second-iteration))
              (xkb-ast-visit context visitor second-iteration)
              (xkb-ast-context-print context "\n%sTHIRD ITERATION" separator)
              (let ((third-iteration
                     (xkb-ast-traverse context (xkb-ast-third-iteration) second-iteration)))
                (xkb-ast-context-print context
                                       "\n%s\nTHIRD ITERATION OUTPUT:\n%s\n"
                                       separator (cl-prin1-to-string third-iteration))
                (xkb-ast-visit context visitor third-iteration)
                (xkb-ast-context-print context "%s\n\n" separator)
                third-iteration)))
           (t (xkb-ast-context-error context "GOT UNKNOWN OUTPUT: %s" (type-of output)))))))
#+end_src

** Full Parser

#+begin_src emacs-lisp
(defun xkb-parse-full ()
  "Run the AST Parser."
  (let ((context (xkb-ast-debug-context)))
    (xkb-ast-with-error-handler
     context
     (let* ((parser (xkb-ast-parser :parser-spec (xkb-ast-first-iteration-parser)))
            (first-iteration (xkb-ast-parser-run parser context))
            (second-iteration (xkb-ast-traverse context (xkb-ast-second-iteration) first-iteration)))
       (xkb-ast-traverse context (xkb-ast-third-iteration) second-iteration)))))
#+end_src

** Interactive Decorations

#+begin_src emacs-lisp
(defun xkb-decorate-buffer ()
  "Interactively decorate the buffer."
  (interactive)
  (xkb--run-interactively
   "`xkb-decorate-buffer'" "*XKB Decorations*"
   ((root (xkb-parse-full)))
   (xkb-ast-add-decorations context root)))
#+end_src

#+begin_src emacs-lisp
(defun xkb-remove-decorations ()
  "Remove all decorations."
  (interactive)
  (delete-all-overlays))
#+end_src

** Interactive Code Formatter

#+begin_src emacs-lisp
(defun xkb-format-buffer ()
  "Interactively format the buffer."
  (interactive)
  (xkb--run-interactively
   "`xkb-format-buffer'" "*XKB Code Formatter*"
   ((root (xkb-parse-full)))
   (xkb-ast-run-formatter context root)))
#+end_src

** Key Map

#+begin_src emacs-lisp
(defvar xkb-mode-map
  (let ((map (make-sparse-keymap))
        (prefix-map (define-prefix-command 'xkb-prefix-map nil nil)))
    (define-key map (kbd "s-c") 'xkb-prefix-map)
    (define-key prefix-map "d" #'xkb-remove-decorations)
    (define-key prefix-map "f" #'xkb-format-buffer)
    (define-key prefix-map "r" #'xkb-parse-buffer)
    (define-key prefix-map "t" #'xkb-decorate-buffer)
    (define-key prefix-map "l" #'xkb-lex-buffer)
    map))
#+end_src

** Mode Definition

#+begin_src emacs-lisp
(define-derived-mode xkb-mode prog-mode "XKB"
  ;; Syntax table.
  (xkb-mode-syntax-table xkb-mode-syntax-table)

  (xkb-setup-wisent)

  (font-lock-mode -1)

  (semantic-mode -1))
#+end_src

* Footer

#+html: <details><summary>File Footer</summary>
#+begin_src emacs-lisp
(provide 'xkb-mode)
#+end_src
#+html: </details>

#+html: <details><summary>File Footer</summary>
#+begin_src emacs-lisp
;;; xkb-mode.el ends here

;; Local Variables:
;; no-byte-compile: t
;; End:
#+end_src
#+html: </details>

#+html: <details><summary>File Footer</summary>
#+begin_src emacs-lisp :tangle xkb-ast.el
(provide 'xkb-ast)
;;; xkb-ast.el ends here

;; Local Variables:
;; no-byte-compile: t
;; End:
#+end_src
#+html: </details>
